"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var _rootNode;
Object.defineProperty(exports, "__esModule", { value: true });
class Node {
    constructor() {
        this.map = new Map();
        this.value = null;
    }
}
class Trie {
    constructor() {
        _rootNode.set(this, new Node());
    }
    set(keys, val) {
        let node = __classPrivateFieldGet(this, _rootNode);
        for (const key of keys) {
            const target = node.map.get(key);
            if (target) {
                node = target;
            }
            else {
                const newNode = new Node();
                node.map.set(key, newNode);
                node = newNode;
            }
        }
        node.value = val;
    }
    get(keys) {
        let node = __classPrivateFieldGet(this, _rootNode);
        for (const key of keys) {
            const target = node.map.get(key);
            if (target) {
                node = target;
            }
            else {
                return undefined;
            }
        }
        return node.value;
    }
}
exports.default = Trie;
_rootNode = new WeakMap();
//# sourceMappingURL=main.js.map